=== debian/changelog ===
rawtherapee (5.8-3) unstable; urgency=medium

  * Bump Standards-Version to 4.5.1 (no changes necessary).
  * Fix copyright entry for com.rawtherapee.RawTherapee.appdata.xml.

 -- Philip Rinn <rinni@inventati.org>  Sun, 20 Dec 2020 13:01:48 +0100

rawtherapee (5.8-2) unstable; urgency=medium

  * Fix sgfault on exit (closes: #961376).
  * Bump debhelper compat to 13 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Sat, 30 May 2020 16:36:09 +0200

rawtherapee (5.8-1) unstable; urgency=medium

  * New upstream release (closes: #951841; LP: #1864300).
  * Update copyright info in d/copyright.
  * Bump Standards-Version to 4.5.0 (no changes necessary).
  * Declare 'Rules-Requires-Root: no' in d/control.

 -- Philip Rinn <rinni@inventati.org>  Sun, 23 Feb 2020 23:08:48 +0100
